/*
Inbox

Inbox API can be used for low level integration and enables direct communication with you contact base.   In most cases you will use our interaction templates for communication, but our api also allows you to send message directly.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package inboxapi

import (
	"encoding/json"
)

// checks if the GetCoupons200Response type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &GetCoupons200Response{}

// GetCoupons200Response struct for GetCoupons200Response
type GetCoupons200Response struct {
	Total int32 `json:"total"`
	Results []Coupon `json:"results"`
}

// NewGetCoupons200Response instantiates a new GetCoupons200Response object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewGetCoupons200Response(total int32, results []Coupon) *GetCoupons200Response {
	this := GetCoupons200Response{}
	this.Total = total
	this.Results = results
	return &this
}

// NewGetCoupons200ResponseWithDefaults instantiates a new GetCoupons200Response object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewGetCoupons200ResponseWithDefaults() *GetCoupons200Response {
	this := GetCoupons200Response{}
	return &this
}

// GetTotal returns the Total field value
func (o *GetCoupons200Response) GetTotal() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.Total
}

// GetTotalOk returns a tuple with the Total field value
// and a boolean to check if the value has been set.
func (o *GetCoupons200Response) GetTotalOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Total, true
}

// SetTotal sets field value
func (o *GetCoupons200Response) SetTotal(v int32) {
	o.Total = v
}

// GetResults returns the Results field value
func (o *GetCoupons200Response) GetResults() []Coupon {
	if o == nil {
		var ret []Coupon
		return ret
	}

	return o.Results
}

// GetResultsOk returns a tuple with the Results field value
// and a boolean to check if the value has been set.
func (o *GetCoupons200Response) GetResultsOk() ([]Coupon, bool) {
	if o == nil {
		return nil, false
	}
	return o.Results, true
}

// SetResults sets field value
func (o *GetCoupons200Response) SetResults(v []Coupon) {
	o.Results = v
}

func (o GetCoupons200Response) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o GetCoupons200Response) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["total"] = o.Total
	toSerialize["results"] = o.Results
	return toSerialize, nil
}

type NullableGetCoupons200Response struct {
	value *GetCoupons200Response
	isSet bool
}

func (v NullableGetCoupons200Response) Get() *GetCoupons200Response {
	return v.value
}

func (v *NullableGetCoupons200Response) Set(val *GetCoupons200Response) {
	v.value = val
	v.isSet = true
}

func (v NullableGetCoupons200Response) IsSet() bool {
	return v.isSet
}

func (v *NullableGetCoupons200Response) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableGetCoupons200Response(val *GetCoupons200Response) *NullableGetCoupons200Response {
	return &NullableGetCoupons200Response{value: val, isSet: true}
}

func (v NullableGetCoupons200Response) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableGetCoupons200Response) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


